package java.lang;

import java.util.Comparator;
import java.io.Serializable;

public final class String extends Object implements Serializable, Comparable, CharSequence {
    public static final Comparator CASE_INSENSITIVE_ORDER = new Comparator() {
        public pure int compare(Object a, Object b) {
            return ((String) a).compareToIgnoreCase((String) b);
        }
        public pure boolean equals(Object o) { return o == this; }
    };

    public String() { }
    public String(String a) { }
    public String(char[] a) { }
    public String(char[] a,int b,int c) { }
    public String(byte[] a,int b,int c,int d) { }
    public String(byte[] a,int b) { }
    public String(byte[] a,int b,int c,String d) throws java.io.UnsupportedEncodingException { }
    public String(byte[] a,String b) throws java.io.UnsupportedEncodingException { }
    public String(byte[] a,int b,int c) { }
    public String(byte[] a) { }
    public String(StringBuffer a) { }
    public pure native int length();
    public pure native char charAt(int a);
    public native void getChars(int a, int b, char[] c, int d);
    public native void getBytes(int a, int b, byte[] c, int d);
    public native byte getBytes(String a)[] throws java.io.UnsupportedEncodingException;
    public native byte[] getBytes();
    public pure native boolean equals(Object a);
    public pure native boolean contentEquals(StringBuffer a);
    public pure native boolean equalsIgnoreCase(String a);
    public pure native int compareTo(String a);
    public pure native int compareTo(Object a);
    public pure native int compareToIgnoreCase(String a);
    public pure native boolean regionMatches(int a, String b, int c, int d);
    public pure native boolean regionMatches(boolean a, int b, String c, int d, int e);
    public pure native boolean startsWith(String a, int b);
    public pure native boolean startsWith(String a);
    public pure native boolean endsWith(String a);
    public pure native int hashCode();
    public pure native int indexOf(int a);
    public pure native int indexOf(int a, int b);
    public pure native int lastIndexOf(int a);
    public pure native int lastIndexOf(int a, int b);
    public pure native int indexOf(String a);
    public pure native int indexOf(String a, int b);
    public pure native int lastIndexOf(String a);
    public pure native int lastIndexOf(String a, int b);
    public native String substring(int a);
    public native String substring(int a, int b);
    public native CharSequence subSequence(int a, int b);
    public native String concat(String a);
    public native String replace(char a, char b);
    public pure native boolean matches(String a);
    public native String replaceFirst(String a, String b);
    public native String replaceAll(String a, String b);
    public native String[] split(String a, int b);
    public native String[] split(String a);
    public native String toLowerCase(java.util.Locale a);
    public native String toLowerCase();
    public native String toUpperCase(java.util.Locale a);
    public native String toUpperCase();
    public native String trim();
    public pure native String toString();
    public pure native char[] toCharArray();
    public native static String valueOf(Object a);
    public native static String valueOf(char[] a);
    public native static String valueOf(char[] a, int b, int c);
    public native static String copyValueOf(char[] a, int b, int c);
    public native static String copyValueOf(char[] a);
    public native static String valueOf(boolean a);
    public native static String valueOf(char a);
    public native static String valueOf(int a);
    public native static String valueOf(long a);
    public native static String valueOf(float a);
    public native static String valueOf(double a);
    public pure native String intern();
}

