package polyglot.ext.predj.parse;

import java.util.*;

import polyglot.ast.*;

// A temporary class used for parsing the MultiJava syntactic sugar
// for multimethod dispatch.
public class PossiblySpecializedFormal {
    protected Formal formal;
    protected TypeNode specializer;
    
    PossiblySpecializedFormal(Formal formal, TypeNode specializer) {
	this.formal = formal;
	this.specializer = specializer;
    }

    public Formal formal() {
	return formal;
    }

    public TypeNode specializer() {
	return specializer;
    }

    public boolean isSpecialized() {
	return specializer != null;
    }

}
