package polyglot.ext.predj.types;

import polyglot.types.*;
import polyglot.ext.jl.types.*;
import polyglot.util.*;
import java.util.*;

/* The type information for a PredJ method that does not have a predicate. */

public class PredJMethodInstance_c extends PredJAbstractMethodInstance_c
{
	// for deserializing types
    protected PredJMethodInstance_c() {
    }
    
    public PredJMethodInstance_c(TypeSystem ts, Position pos,
				 ReferenceType container,
				 Flags flags, Type returnType, String name,
				 List formalTypes, List excTypes) {
        super(ts, pos, container, flags, returnType, name,
	      formalTypes, excTypes);
    }

    public boolean equalsImpl(TypeObject m) {
	if (m instanceof PredJMethodInstance &&
	    !(m instanceof PredJPredMethodInstance))
	    return super.equalsImpl(m);
	return false;
    }
    
//     /** Returns true iff <this> is the same method as <m> */
//     public boolean isSameMethodImpl(MethodInstance m) {
// 	if (m instanceof PredJMethodInstance &&
// 	    !(m instanceof PredJPredMethodInstance))
// 	    return super.isSameMethodImpl(m);
// 	return false;
//     }

}
